<template>
  <v-form class="form-style" @submit.prevent>
    <v-card-item>
      <h1 class="mb-4">Ticket erstellen</h1>

      <v-text-field
          v-model="ticket.title"
          :rules="titleRules"
          :counter="8"
          label="Titel"
          type="text"
          required
          variant="outlined"
          maxlength="255"/>

      <v-text-field
          class="description-box"
          v-model="ticket.description"
          :rules="descriptionRules"
          :counter="2000"
          label="Beschreibung"
          type="text"
          required
          variant="outlined"
          maxlength="2000"
          autocomplete="email"/>

      <v-select
          label="Priorität"
          :items="['VERY_IMPORTANT', 'IMPORTANT', 'MODERATE', 'LESS_IMPORTANT']"
          v-model="ticket.priority"
      ></v-select>

      <v-select
          label="Abteilung"
          :items="departments"
          v-model="ticket.department"
      ></v-select>

      <p>Anhang (optional)</p>
      <upload-image @file-uploaded="handleFileUpload"></upload-image>
      <v-btn type="submit" color="blue-darken-4" block class="mt-15" @click="createTicket">Ticket Erstellen</v-btn>
      <v-snackbar location="bottom end">
        Ein unbekannter Fehler ist aufgetreten. Bitte versuchen Sie es später erneut.
      </v-snackbar>
    </v-card-item>
  </v-form>
</template>

<script setup>

import {useDepartmentStore} from "@/stores/departmentStore";
import {computed, onMounted, ref, toRaw} from "vue";
import UploadImage from "@/components/FileUpload.vue";
import {useAuthStore} from "@/stores/authStore";
import {useTicketStore} from "@/stores/ticketStore";

//STORES
const departmentStore = useDepartmentStore();
const authStore = useAuthStore();
const ticketStore = useTicketStore();
const user = authStore.user;

//EMITS & PROPS
const emit = defineEmits(['dialog']);
const props = defineProps(['page']);

//VARIABLES
const departments = computed(() => toRaw(departmentStore.departments));
let fileName = ref(null);
const ticket = ref({
  title: "",
  description: "",
  priority: "",
  department: ""
})

//RULES
const titleRules = computed(() => [
  value => {
    if (value) return true;

    return 'Bitte gib einen Titel an.';
  },
  value => {
    if (value && value.length >= 8) return true;

    return 'Title muss aus mindestens 8 Zeichen bestehen.';
  },
]);

const descriptionRules = computed(() => [
  value => {
    if (value) return true;

    return 'Bitte gib eine Beschreibung an.';
  },
  value => {
    if (value && value.length <= 2000) return true;

    return 'Beschreibung darf nicht aus mehr als 2000 Zeichen bestehen.';
  },
]);

//Lifecyclehooks
onMounted(async () => {
  await departmentStore.getDepartments();
});

//Functions
const handleFileUpload = (uploadedFileName) => {
  fileName.value = uploadedFileName;
};

async function createTicket() {
  try {
    if (ticket.value.title.length > 0 &&
        ticket.value.description.length > 0 &&
        ticket.value.priority.length > 0 &&
        ticket.value.department.length > 0) {
      await ticketStore.createTicket(authStore.user.username, ticket.value)
      await ticketStore.getTickets(props.page)
      emit('dialog')
      alert("Ticket wurde erfolgreich erstellt.")

      if (fileName.value !== null) { //Set relation between file and ticket, if file is uploaded
        await ticketStore.putTicketFileRelation(fileName.value, ticket.value)
      }

    } else {
      alert("Du musst alle Felder ausfüllen!")
    }
  } catch (error) {
    alert("Etwas ist schief gelaufen.")
    console.log("error: ", error)
  }
}
</script>

<style scoped>
.form-style {
  width: 700px;
}
</style>